'gbForumCodeLite by Gary Beene
#Compile Exe
#Dim All
'#Debug Error On     'catch array/pointer errors - OFF in production
'#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32api.inc"
#Resource "gbforumcodelite.pbr"

Global endBlock As String, endKey As String
Global cKeyStr, cRemStr, cSymStr, cNumStr, cASMStr, cQuoStr, cAPIStr, cUserStr As String
Global APICase, KeyCase, SoundBite, UseProcList, AutoViewVCode As Long
Global apiStart() As Long, apiCount() As Long
Global SoundBite, cLenStr, cLenEnd As Long
Global FontName As String, FontSize, FontAttr, NoFont, HighlightSymbols As Long

Global LKeys(), UKeys(), MKeys(), LAPI(), UAPI(), MAPI() As String
Global LUser(), UUser(), MUser(), vCode As String
Global hDlg, hMainImageList As Dword
Global cKeyword, cRemark, cSymbol, cNumber, cAssembler, cQuote, cAPI As Long

Function PBMain() As Long
    Local iReturn As Long
    Settings_INI "get"
    CreateMainImageList
    synInitializeRWords
    If UseProcList Then BuildProcedureList
    CreateVCode
    CopyVCode
    Settings_INI "save"
    If SoundBite Then sndPlaySound("MailBeep", %SND_SYNC)    'play sound once (in the background)
    If AutoViewVCode Then ViewVCode
End Function

Sub CreateMainImageList
    ImageList Kill hMainImageList
    ImageList New Icon 24,24,32,50 To hMainImageList
    ImageList Add Icon hMainImageList, "logolite"           '1
End Sub

Sub synInitializeRWords
   Local temp$, i As Long
   ReDim UKeys(1000), LKeys(1000), MKeys(1000)
   ReDim UAPI(5000), LAPI(5000), MAPI(5000)

   Open EXE.Path$ + "gbforumcode_api.txt" For Input As #1
   While IsFalse Eof(1)
      Line Input #1, temp$
      If Len(Trim$(temp$)) Then
         MAPI(i) = temp$
         UAPI(i) = UCase$(temp$)
         LAPI(i) = LCase$(temp$)
         Incr i
      End If
   Wend
   Close #1
   ReDim Preserve UAPI(i-1), LAPI(i-1), MAPI(i-1)

   i = 0
   Open EXE.Path$ + "gbforumcode_key.txt" For Input As #1
   While IsFalse Eof(1)
     Line Input #1, temp$
     If Len(Trim$(temp$)) Then
        MKeys(i) = temp$
        UKeys(i) = UCase$(MKeys(i))
        LKeys(i) = LCase$(MKeys(i))
        Incr i
     End If
   Wend
   Close #1
   ReDim Preserve UKeys(i-1), LKeys(i-1), MKeys(i-1)

End Sub

Sub Settings_INI(task$)
   Local temp As Asciiz*%Max_Path, INIFileName As Asciiz*%Max_Path
   INIFileName = EXE.Path$ + "gbforumcodelite.ini"

   If task$ = "get" Then

       Getprivateprofilestring "All", "HighlightSymbols", "1", temp, %Max_Path, INIFileName
       HighlightSymbols = Val(temp)

       Getprivateprofilestring "All", "AutoViewVCode", "0", temp, %Max_Path, INIFileName
       AutoViewVCode = Val(temp)

       Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName
       FontSize = Val(temp)

       Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName
       FontAttr = Val(temp)

       Getprivateprofilestring "All", "FontName", "Consolas", temp, %Max_Path, INIFileName
       FontName = temp

       Getprivateprofilestring "All", "NoFont", "1", temp, %Max_Path, INIFileName
       NoFont = Val(temp)

       Getprivateprofilestring "All", "UseProcList", "0", temp, %Max_Path, INIFileName
       UseProcList = Val(temp)

       Getprivateprofilestring "All", "SoundBite", "1", temp, %Max_Path, INIFileName
       SoundBite = Val(temp)

       Getprivateprofilestring "All", "APICase", "2", temp, %Max_Path, INIFileName
       APICase = Val(temp)

       Getprivateprofilestring "All", "KeyCase", "2", temp, %Max_Path, INIFileName
       KeyCase = Val(temp)

       Getprivateprofilestring "Color", "Keyword", "FF0000", temp, %Max_Path, INIFileName
       cKeyword = Val("&H" + temp)

       Getprivateprofilestring "Color", "Remark", "008000", temp, %Max_Path, INIFileName
       cRemark = Val("&H" + temp)

       Getprivateprofilestring "Color", "ESymbol", "0000FF", temp, %Max_Path, INIFileName
       cSymbol = Val("&H" + temp)

       Getprivateprofilestring "Color", "Number", "000040", temp, %Max_Path, INIFileName
       cNumber = Val("&H" + temp)

       Getprivateprofilestring "Color", "Assembler", "8F8F8F", temp, %Max_Path, INIFileName
       cAssembler = Val("&H" + temp)

       Getprivateprofilestring "Color", "Quote", "0000FF", temp, %Max_Path, INIFileName
       cQuote = Val("&H" + temp)

       Getprivateprofilestring "Color", "API", "FF0080", temp, %Max_Path, INIFileName
       cAPI = Val("&H" + temp)

   Else

      temp = " " + Str$(HighlightSymbols)
      WritePrivateProfileString "All", "HighlightSymbols", temp, INIFileName

      temp = " " + Str$(AutoViewVCode)
      WritePrivateProfileString "All", "AutoViewVCode", temp, INIFileName

      temp = " " + Str$(FontSize)
      WritePrivateProfileString "All", "FontSize", temp, INIFileName

      temp = " " + Str$(FontAttr)
      WritePrivateProfileString "All", "FontAttr", temp, INIFileName

      temp = " " + FontName
      WritePrivateProfileString "All", "FontName", temp, INIFileName

      temp = " " + Str$(NoFont)
      WritePrivateProfileString "All", "NoFont", temp, INIFileName

      temp = " " + Str$(UseProcList)
      WritePrivateProfileString "All", "UseProcList", temp, INIFileName

      temp = " " + Str$(SoundBite)
      WritePrivateProfileString "All", "SoundBite", temp, INIFileName

      temp = " " + Str$(APICase)
      WritePrivateProfileString "All", "APICase", temp, INIFileName

      temp = " " + Str$(KeyCase)
      WritePrivateProfileString "All", "KeyCase", temp, INIFileName

      temp = " " + Hex$(cKeyword,6)
      WritePrivateProfileString "Color", "Keyword", temp, INIFileName

      temp = " " + Hex$(cRemark,6)
      WritePrivateProfileString "Color", "Remark", temp, INIFileName

      temp = " " + Hex$(cSymbol,6)
      WritePrivateProfileString "Color", "ESymbol", temp, INIFileName

      temp = " " + Hex$(cNumber,6)
      WritePrivateProfileString "Color", "Number", temp, INIFileName

      temp = " " + Hex$(cAssembler,6)
      WritePrivateProfileString "Color", "Assembler", temp, INIFileName

      temp = " " + Hex$(cQuote,6)
      WritePrivateProfileString "Color", "Quote", temp, INIFileName

      temp = " " + Hex$(cAPI,6)
      WritePrivateProfileString "Color", "API", temp, INIFileName


   End If

End Sub

Sub CopyVCode
    Clipboard Reset
    Clipboard Set Text vCode
    Open EXE.Path$ + "gbforumcodelite_vcode.txt" For Output As #1
    Print #1, vCode
    Close #1
End Sub

Sub BuildProcedureList
   Local i, pCount As Long, tmp$, ProcListBuf$
   Local w1$, w2$, w3$, w4$, s1$, s2$, s3$, s4$, s12$, s123$

   ReDim MUser(1000)
   Clipboard Get Text To ProcListBuf$
   Dim BufArray(ParseCount(ProcListBuf$,$CrLf)-1) As String   'break input string into an array
   Parse ProcListBuf$, BufArray(), $CrLf

   For i = 0 To UBound(BufArray)
      tmp$ = LTrim$(Retain$(BufArray(i), Any Chr$(65 To 90, 95, 97 To 122, 48 To 57, $Spc, "()=")))
      Replace Any "()" With "  " In tmp$
      While InStr(tmp$, "  ") : Replace "  " With " " In tmp$ : Wend  'remove all pairs of spaces
      w1$ = Parse$(tmp$," ",1) : w2$ = Parse$(tmp$," ",2) : w3$ = Parse$(tmp$," ",3) : w4$ = Parse$(tmp$," ",4)
      s1$ = LCase$(w1$) : s2$ = LCase$(w2$) : s3$ = LCase$(w3$) : s4$ = LCase$(w4$) : s12$ = Build$(s1$," ",s2$)
      If s1$   = "sub"                           Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "callback function"             Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "function" And w2$ <> "="       Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "macro function"                Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "macro"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "thread function"               Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "class"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "class method"                  Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s12$  = "override method"               Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "method" And w2$ <> "="         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s1$   = "interface"                     Then MUser(pCount) = w2$ : Incr pCount : Iterate For
   Next i

   ReDim Preserve MUser(IIf(pCount>0, pCount-1, pCount))
   ReDim Preserve LUser(UBound(MUser)), UUser(UBound(MUser))
   Array Sort MUser()
   For i = 0 To UBound(MUser) : LUser(i) = LCase$(MUser(i)) : UUser(i) = UCase$(MUser(i)) : Next i
End Sub

Function BinaryWordSearch_User(sWord As String, iPos As Long) As Long
    Local Upper, Lower As Long
    Lower = LBound(UUser) : Upper = UBound(UUser)
    'test boundary values
    If sWord = UUser(Lower) Then iPos& = Lower : Function = 1 : Exit Function
    If sWord = UUser(Upper) Then iPos& = Upper : Function = 1 : Exit Function
    If sWord < UUser(Lower) Then iPos& = Lower - 1 : Function = 0 : Exit Function
    If sWord > UUser(Upper) Then iPos& = Upper + 1 : Function = 0 : Exit Function
    'search the rest of the array
    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        If sWord > UUser(iPos&) Then
           Lower = iPos
        ElseIf sWord < UUser(iPos&) Then
           Upper = iPos
        Else
           Function = 1 : Exit Function
        End If
    Loop
End Function

Function BinaryWordSearch_Key(sWord As String, iPos As Long) As Long
    Local Upper, Lower As Long
    Lower = LBound(UKeys) : Upper = UBound(UKeys)
    'test boundary values
    If sWord = UKeys(Lower) Then iPos& = Lower : Function = 1 : Exit Function
    If sWord = UKeys(Upper) Then iPos& = Upper : Function = 1 : Exit Function
    If sWord < UKeys(Lower) Then iPos& = Lower - 1 : Function = 0 : Exit Function
    If sWord > UKeys(Upper) Then iPos& = Upper + 1 : Function = 0 : Exit Function
    'search the rest of the array
    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        If sWord > UKeys(iPos&) Then
           Lower = iPos
        ElseIf sWord < UKeys(iPos&) Then
           Upper = iPos
        Else
           Function = 1 : Exit Function
        End If
    Loop
End Function

Function BinaryWordSearch_API(sWord As String, iPos As Long) As Long
    Local Upper, Lower As Long
    Lower = LBound(UAPI) : Upper = UBound(UAPI)
    'test boundary values
    If sWord = UAPI(Lower) Then iPos = Lower : Function = 1 : Exit Function
    If sWord = UAPI(Upper) Then iPos = Upper : Function = 1 : Exit Function
    If sWord < UAPI(Lower) Then iPos = Lower - 1 : Function = 0 : Exit Function
    If sWord > UAPI(Upper) Then iPos = Upper + 1 : Function = 0 : Exit Function
    'search the rest of the array
    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        If sWord > UAPI(iPos) Then
           Lower = iPos
        ElseIf sWord < UAPI(iPos) Then
           Upper = iPos
        Else
           Function = 1 : Exit Function
        End If
    Loop
End Function

Sub CreateVCode
  'Convert code to vBulletin encoded text
  'Parser builds syntax colored RTF. Use pointers and pre-allocated output string for speed
  Local ii As Long, Ac As Long, stopPos As Long, Result As Long, iPos As Long
  Local wFlag As Long, remFlag As Long, dqFlag As Long, cWordStr As String, slashFlag As Long
  Local pLet As Byte Ptr, pLet2 As Byte Ptr
  Local tmpWord As String, vBuf As String, vCaseBuf As String

  MousePtr 11             'show Hourglass mouse pointer during process

  'starting blocks
  cKeyStr    = "[color=#" + Hex$(Bgr(cKeyword),6) + "]"    'Keys
  cRemStr    = "[color=#" + Hex$(Bgr(cRemark),6) + "]"    'Remarks
  cSymStr    = "[color=#" + Hex$(Bgr(cSymbol),6) + "]"    'Symbols
  cNumStr    = "[color=#" + Hex$(Bgr(cNumber),6) + "]"    'Numbers
  cASMStr    = "[color=#" + Hex$(Bgr(cAssembler),6) + "]"    'ASM
  cQuoStr    = "[color=#" + Hex$(Bgr(cQuote),6) + "]"    'Quotes
  cAPIStr    = "[color=#" + Hex$(Bgr(cAPI),6) + "]"    'API
  cUserStr   = "[color=#" + Hex$(Bgr(cAPI),6) + "]"    'User
  cLenStr = Len(cKeyStr)

  'ending blocks
  endBlock   = "[/color]"  'block end
  endKey     = "[/colob]"  'use temporary block end for blue color, to enable size trim
  cLenEnd = Len(endBlock)

  Clipboard Get Text To vCode
  vCode = vCode + " "
  vBuf     = String$(Max&(1000, 10 * Len(vCode)), 0) 'create enough big output buffer
  vCaseBuf = UCase$(vCode)          'use uppercase string for compare
  pLet     = StrPtr(vCode)          'pointer to global string (input)
  pLet2    = StrPtr(vBuf)        'pointer to output buffer

  For ii = 1 To Len(vCode)
     Select Case @pLet            'the characters we need to inlude in a word
        Case 65 To 90, 97 To 122, 35 To 37, 48 To 57, 63, 95, 46
           If wFlag = 0 And remFlag = 0 And dqFlag = 0 Then
              wFlag = 1 : stopPos = ii
           End If

        Case 34 ' double quote -> "
           If dqFlag = 0 And remFlag = 0 Then  'if start of string literal
              Poke$ pLet2, cQuoStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
              dqFlag = 1 : wFlag = 0                              'since now inside DQ, wordflag is off
           ElseIf dqFlag = 1 Then                                 'should be end of DQ block
              @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
              Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
              dqFlag = 3                                          'end of DQ - set DQ flag
           End If

        Case 59 ' asm comment character -> ;
           If remFlag = 0 And dqFlag = 2 Then
              Poke$ pLet2, endBlock   :  pLet2 = pLet2 + cLenEnd   'put endblock, move pointer
              Poke$ pLet2, cRemStr    :  pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              remFlag = 1 : wFlag = 0
           End If

        Case 39 ' uncomment character -> '
           If remFlag = 0 And dqFlag <> 1 Then
              If dqFlag = 2 Then
                 Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd   'put endblock, move pointer
              End If
              Poke$ pLet2, cRemStr     : pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              remFlag = 1 : wFlag = 0
           End If

        Case 33 ' asm line start -> !
           If remFlag = 0 And dqFlag = 0 Then
              Poke$ pLet2, cASMStr     : pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              dqFlag = 2 : wFlag = 0
           End If

        Case Else  'word is ready
           If @pLet = 13 Then    'if CRLF - end of line
              If remFlag Or dqFlag Then   'if in rem, asm or unfinished string literal (DQ)
                 Poke$ pLet2, endBlock  : pLet2 = pLet2 + cLenEnd   'put value, move pointer
                 remFlag = 0 : wFlag = 0 : dqFlag = 0  'reset all flags
              End If
           End If

           If wFlag = 1 Then 'if we have a word
              tmpWord = Mid$(vCaseBuf, stopPos, ii - stopPos)  'Get word
              Result = 0

              If BinaryWordSearch_Key(tmpWord,iPos) Then
                  tmpWord = Choose$(KeyCase,LKeys(iPos), MKeys(iPos), UKeys(iPos))
                  cWordStr = cKeyStr : Result = 1
              ElseIf BinaryWordSearch_API(tmpWord,iPos) Then
                  tmpWord = Choose$(APICase,LAPI(iPos), MAPI(iPos), UAPI(iPos))
                  cWordStr = cAPIStr : Result = 1
              ElseIf UseProcList And BinaryWordSearch_User(tmpWord,iPos) Then
                  tmpWord = Choose$(APICase,LUser(iPos), MUser(iPos), UUser(iPos))
                  cWordStr = cUserStr : Result = 1
              End If

              If Result Then   'word match found (API, Keyword, User)
                 If tmpWord = "REM" Then
                    pLet2 = pLet2 - 3                                      'position to start of word
                    Poke$ pLet2, cRemStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                    Poke$ pLet2, tmpWord   : pLet2 = pLet2 + 3             'put value, move opinter
                    remFlag = 1
                 ElseIf tmpWord = "ASM" Then
                    pLet2 = pLet2 - 3                                      'position to start of word
                    Poke$ pLet2, cASMStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                    Poke$ pLet2, tmpWord   : pLet2 = pLet2 + 3             'put value, move pointer
                    dqFlag = 2
                 Else
                     pLet2 = pLet2 - Len(tmpWord)                          'position to start of word
                     Poke$ pLet2, cWordStr  : pLet2 = pLet2 + cLenStr      'put preblock, move pointer
                     Poke$ pLet2, tmpWord   : pLet2 = pLet2 + Len(tmpWord) 'put value, move pointer
                     Poke$ pLet2, endKey    : pLet2 = pLet2 + cLenEnd '15  'put endblock, move pointer
                 End If
              ElseIf Verify(tmpWord, ".0123456789") = 0 Then
                     pLet2 = pLet2 - Len(tmpWord) 'set position to start of word
                     Poke$ pLet2, cNumStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                     Poke$ pLet2, tmpWord   : pLet2 = pLet2 + Len(tmpWord)  'put value, move pointer
                     Poke$ pLet2, endBlock  : pLet2 = pLet2 + cLenEnd       'put endblock, move pointer
              End If
              wFlag = 0
           End If
     End Select

     If dqFlag <> 3 Then
         If (remFlag = 0) And (dqFlag = 0) And HighlightSymbols Then
            Select Case @pLet   'Chr$(@Letter)
    '               =   *   +   -   /   <   >   ^   (  )
             Case  61, 42, 43, 45, 47, 60, 62, 94, 40, 41   ' 92=\ missing
                 Poke$ pLet2, cSymStr     : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                 @pLet2 = @pLet           : pLet2 = pLet2 + 1           'put value, move pointer
                 Poke$ pLet2, endBlock    : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
              Case  92  ' "\"
                 If slashFlag = 0 Then
                    Poke$ pLet2, cSymStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    slashFlag = 1
                 ElseIf Peek(pLet+1)<>92 Then
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
                    slashFlag = 0
                 Else
                    @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
                 End If
              Case  38  ' "&"
                 If Peek(pLet-1)=32 And Peek(pLet+1)=32 Then
                    Poke$ pLet2, cSymStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
                 Else
                    @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
                 End If
              Case Else
                 @pLet2 = @pLet           : Incr pLet2                  'put char, move pointer
            End Select
         Else
             @pLet2 = @pLet               :  Incr pLet2                 'put char, move pointer
         End If
     Else
        dqFlag = 0             'else reset DQ flag
     End If
     Incr pLet                 'move pointer to next character
  Next ii

  If remFlag Then Poke$ pLet2, endBlock

  vCode = Extract$(vBuf, Chr$(0))      'extract result (and remove the added space)
  Replace endKey + " " + cKeyStr With " " In vCode    'Trim size: If keywords follows each other,
  Replace endKey With endBlock In vCode               'replace remaining Key endblocks with proper RTF

  vCode = vbHeader + vCode + vbFooter
  MousePtr 1       'done, so time to reset mouse pointer
End Sub

Function vbHeader() As String
    Local temp$
    If NoFont Then
        temp$ = "[co" + "de]"
    Else
        temp$ = "[co" + "de][fo" + "nt=" + FontName + "]"
        If FontSize > 14 Then
            temp$ = temp$ + "[si" + "ze=+2]"
        ElseIf FontSize > 10 Then
            temp$ = temp$ + "[si" + "ze=+1]"
        End If
        temp$ = temp$ + Choose$(FontAttr, "[b"+"]","[i"+"]","[b"+"][i"+"]")
    End If
    Function = temp$
End Function

Function vbFooter() As String
    Local temp$
    If NoFont Then
        temp$ = "[/co" + "de]"
    Else
        temp$ = "[/fo" + "nt][/co" + "de]
        If FontSize > 10 Then temp$ = "[/si" + "ze]" + temp$
        temp$ = Choose$(FontAttr, "[/"+"b]","[/"+"i]","[/"+"i][/"+"b]") + temp$
    End If
    Function = temp$
End Function

Sub ViewVCode
    Local iReturn As Long
    iReturn = Shell("notepad.exe " + EXE.Path$ + "gbforumcodelite_vcode.txt", 1)    'does not wait
End Sub
